/**
* {{&summary}}
* request: {{&methodName}}
* url: {{&methodName}}URL
* method: {{&methodName}}_TYPE
* raw_url: {{&methodName}}_RAW_URL
{{#parameters}}
    {{^isSingleton}} * @param {{&camelCaseName}} - {{&description}}{{/isSingleton}}
{{/parameters}}
*/
export const {{&methodName}} = function(parameters = {}) {
    const domain = parameters.$domain ? parameters.$domain : getDomain()
    const config = parameters.$config
    let path = '{{&path}}'
    let body
    let queryParameters = {}
    let formData = null

{{#parameters}}
    {{#isQueryParameter}}
        if(parameters['{{&camelCaseName}}'] !== undefined) {
            queryParameters['{{&name}}'] = parameters['{{&camelCaseName}}']
        }
    {{/isQueryParameter}}

    {{#isPathParameter}}
        path = path.replace('{{brackets name}}', `${parameters['{{&camelCaseName}}']}`)
    {{/isPathParameter}}

    {{#isBodyParameter}}
        if(parameters['{{&camelCaseName}}'] !== undefined) {
            body = parameters['{{&camelCaseName}}']
        }
    {{/isBodyParameter}}

    {{#isFormParameter}}
        formData = new FormData()
        Object.keys(parameters).forEach(key => {
            formData.append(key, parameters[key])
        })
    {{/isFormParameter}}

    {{#required}}
        if(parameters['{{&camelCaseName}}'] === undefined) {
            return Promise.reject(new Error('Missing required {{&paramType}} parameter: {{&camelCaseName}}'))
        }
    {{/required}}

{{/parameters}}

if(parameters.$queryParameters) {
    Object.keys(parameters.$queryParameters).forEach(function(parameterName){
        queryParameters[parameterName] = parameters.$queryParameters[parameterName]
    });
}

    return request('{{toLowerCase method}}', domain + path, body, queryParameters, formData, config)
}

export const {{&methodName}}_RAW_URL = function () {
  return '{{&path}}'
}
export const {{&methodName}}_TYPE = function () {
  return '{{toLowerCase method}}'
}
export const {{&methodName}}URL = function(parameters = {}){
    let queryParameters = {}
    const domain = parameters.$domain ? parameters.$domain : getDomain()
    let path = '{{&path}}'
    {{#parameters}}
        {{#isQueryParameter}}
            if(parameters['{{&camelCaseName}}'] !== undefined){
                queryParameters['{{&name}}'] = parameters['{{&camelCaseName}}']
            }
        {{/isQueryParameter}}
        {{#isPathParameter}}
            path = path.replace('{{brackets name}}', `${parameters['{{&camelCaseName}}']}`)
        {{/isPathParameter}}
    {{/parameters}}

    if(parameters.$queryParameters) {
        Object.keys(parameters.$queryParameters).forEach(function(parameterName) {
            queryParameters[parameterName] = parameters.$queryParameters[parameterName]
        })
    }

    let keys = Object.keys(queryParameters)
    return domain + path + (keys.length > 0 ? '?' + (keys.map(key => key + '=' + encodeURIComponent(queryParameters[key])).join('&')): '')
}
